Qore Programming Language Reference Manual: Qore::SQL::DatasourcePool Class Reference

Qore Programming Language Reference Manual 0.8.11

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Groups Pages
Public Member Functions | List of all members
Qore::SQL::DatasourcePool Class Reference

Provides transparent per-thread, per-transaction datasource connection pooling. More...

Inheritance diagram for Qore::SQL::DatasourcePool:
[legend]

## Public Member Functions
nothing | beginTransaction ()
| Manually allocates a persistent connection from the pool to the calling thread. More...
nothing | clearEventQueue ()
| Clears the queue object for DBI events on the pool. More...
| clearWarningCallback ()
| clears any connection delay warning callback from the object More...
nothing | commit ()
| Commits the current transaction and releases the connection to the pool. More...
| constructor (string driver, *string user, *string pass, *string db, *string encoding, *string host, softint min=3, softint max=10, softint port=0, *Qore::Thread::Queue queue, any arg)
| Creates the DatasourcePool object; attempts to load a DBI driver if the driver is not already present in Qore. More...
| constructor (string desc, *Qore::Thread::Queue queue, any arg)
| Creates a DatasourcePool object from a single string giving all parameters that can be parsed by parse_datasource() More...
| constructor (hash opts, *Qore::Thread::Queue queue, any arg)
| Creates a Datasource object from a hash argument giving parameters for the constructor. More...
| copy ()
| Creates a new Datasource object with the same driver as the original and copies of all the connection parameters. More...
bool | currentThreadInTransaction ()
| Returns True if the current thread is in a transaction (i.e. has a dedicated datasource allocation), False if not. More...
| destructor ()
| Throws an exception if any transactions are in progress and returns immediately; the object is destroyed after any in-progress requests are completed. More...
any | exec (string sql,...)
| Allocates a persistent connection to the current thread from the pool (if one has not already been allocated) and executes an SQL command on the server and returns either the integer row count (for example, for updates, inserts, and deletes) or the data retrieved (for example, if a stored procedure is executed that returns values) More...
any | execRaw (string sql)
| Allocates a persistent connection to the current thread from the pool (if one has not already been allocated) and executes an SQL command on the server and returns either the row count (for example, for updates and inserts) or the data retrieved (for example, if a stored procedure is executed that returns values) More...
any | getClientVersion ()
| Retrieves the driver-specific client library version information; this method may not be implemented for all drivers. More...
hash | getConfigHash ()
| Returns a datasource hash describing the configuration of the current object. More...
string | getConfigString ()
| Returns a string giving the configuration of the current object in a format that can be parsed by parse_datasource() More...
*string | getDBCharset ()
| Retrieves the database-specific charset set encoding for the object. More...
string | getDBEncoding ()
| Retrieves the database-specific charset set encoding for the object. More...
*string | getDBName ()
| Returns the database name parameter as a string or NOTHING if none is set. More...
string | getDriverName ()
| Returns the name of the driver used for the object. More...
int | getErrorTimeout ()
| Returns the error timeout period for waiting for a connection to come free as an integer giving milliseconds; note that timeout values less than or equal to zero mean that requests for a connection will wait indefinitely. More...
*string | getHostName ()
| Returns the hostname parameter as a string or NOTHING if none is set. More...
int | getMaximum ()
| Returns the maximum number of connections in this object. More...
int | getMinimum ()
| Returns the minimum number of connections in this object. More...
string | getOSCharset ()
| Returns the Qore character encoding name for the object as a string or `"(unknown)"` if none is set. More...
*string | getOSEncoding ()
| Returns the Qore character encoding name for the object as a string or NOTHING if none is set. More...
any | getOption (string opt)
| Returns the current value for the given option. More...
hash | getOptionHash ()
| returns the valid options for the driver associated with the Datasource with descriptions and current values for the current Datasource object More...
*string | getPassword ()
| Returns the password parameter as a string or NOTHING if none is set. More...
*int | getPort ()
| Gets the port number that will be used for the next connection to the server. More...
any | getServerVersion ()
| Returns the driver-specific server version data for the current connection. More...
*hash | getUsageInfo ()
| Returns a hash with usage information about the DatasourcePool object. More...
*string | getUserName ()
| Returns the username parameter as a string or NOTHING if none is set. More...
bool | inTransaction ()
| Returns True if a transaction is currently in progress (meaning in this case that a datasource form the pool is dedicated to the calling thread), False if not. More...
nothing | rollback ()
| Rolls back the current transaction and releases the connection to the pool. More...
any | select (string sql,...)
| Executes an SQL select statement on the server and returns the result as a hash (column names) of lists (column values per row) More...
any | selectRow (string sql,...)
| Executes an SQL select statement on the server and returns the first row as a hash (the column values) More...
any | selectRows (string sql,...)
| Executes an SQL select statement on the server and returns the result as a list (rows) of hashes (the column values) More...
| setErrorTimeout (timeout ts)
| Sets the timeout period for waiting for a connection to come free; note that timeout values less than or equal to zero mean that requests for a connection will wait indefinitely. More...
nothing | setEventQueue (Qore::Thread::Queue queue, any arg)
| Sets a queue object for DBI events on the pool. More...
| setWarningCallback (timeout ms, code callback, any arg)
| sets a connection delay warning callback to be called any time the delay assigning a connection from the pool exceeds the given timeout in milliseconds More...
string | toString ()
| Returns a string with technical information about the object. More...
any | vexec (string sql, *softlist vargs)
| Allocates a persistent connection to the current thread from the pool (if one has not already been allocated) and executes SQL code on the DB connection, taking a list for all bind arguments. More...
any | vselect (string sql, *softlist vargs)
| Executes a select statement on the server and returns the results in a hash (column names) of lists (column values per row), taking a list for all bind arguments. More...
any | vselectRow (string sql, *softlist vargs)
| Executes a select statement on the server and returns the first row as a hash (column names and values), taking a list for all bind arguments. More...
any | vselectRows (string sql, *softlist vargs)
| Executes a select statement on the server and returns the results in a list (rows) of hashes (column names and values), taking a list for all bind arguments. More...
Public Member Functions inherited from Qore::SQL::AbstractDatasource
bool | currentThreadInTransaction ()
| Should return True if the current thread is in a transaction with this object, must be re-implemented in subclasses to provide the desired functionality. More...

## Detailed Description

Provides transparent per-thread, per-transaction datasource connection pooling.

Restrictions:
  Qore::PO_NO_DATABASE

In most cases, the DatasourcePool class can be used as a drop-in replacement for the Datasource class with autocommit disabled; when a transaction begins, a datasource will be automatically assigned to the calling thread, and it will only be released when a commit or rollback is called on the object. If no datasource is available, the calling thread will block until a datasource comes available.

Note that the same principles apply to SQL and database driver usage as with the Datasource class, see the Datasource class documentation for more information.

The DatasourcePool class uses Qore's thread resource tracking infrastructure to raise an exception if a thread terminates while a connection is allocated to it. If Qore user code enters a transaction with a DatasourcePool object and the thread terminates without closing the transaction (via DatasourcePool::commit() or DatasourcePool::rollback()), an exception will automatically be raised, the transaction will be rolled back, and the Datasource connection will be freed to the pool.

DatasourcePool Connection Allocations

The following methods allocate a persistent connection to the calling thread:

- DatasourcePool::exec()
- DatasourcePool::vexec()
- DatasourcePool::execRaw()
- DatasourcePool::beginTransaction()

The connection is released to the pool when DatasourcePool::commit() or DatasourcePool::rollback() are called (or in the case the thread terminates, in which case an exception is raised as well).

To begin a transaction with one of the select methods (for example, with `"select for update"`), call DatasourcePool::beginTransaction() first to manually dedicate a Datasource to the thread before calling the select method. Otherwise statements that should be in the same transaction may be executed in different connections.

Executing a DatasourcePool method while not in a transaction is realized by allocating a temporary connection to the calling thread which is re-released when the method returns. No explicit commits are executed by the class, therefore it is an error to execute transaction-relevant commands without first calling DatasourcePool::exec(), DatasourcePool::vexec(), DatasourcePool::execRaw(), or DatasourcePool::beginTransaction().

Note that the SQLStatement class also grabs allocates a persistent connection to the calling thread when executing if it is created using a DatasourcePool object in the constructor; for more information see the SQLStatement class.

Note
  This class is not available with the PO_NO_DATABASE parse option

See Also
  SqlUtil for a high level database-independent API

## Member Function Documentation

nothing Qore::SQL::DatasourcePool::beginTransaction | ( |  | ) |
| virtual

Manually allocates a persistent connection from the pool to the calling thread.

This method should be called when a transaction will be started with a DatasourcePool::select() method (or DatasourcePool::vselect(), etc).

This method does not make any communication with the server to start a transaction; it only allocates a persistent connection to the current thread in Qore.

To release the connection, call DatasourcePool::commit() or DatasourcePool::rollback()

Example:
  $db.beginTransaction();

Implements Qore::SQL::AbstractDatasource.

nothing Qore::SQL::DatasourcePool::clearEventQueue | ( |  | ) |

Clears the queue object for DBI events on the pool.

Since
  Qore 0.8.9

Qore::SQL::DatasourcePool::clearWarningCallback | ( |  | ) |

clears any connection delay warning callback from the object

Example:
  $ds.clearWarningCallback();

Since
  Qore 0.8.9

nothing Qore::SQL::DatasourcePool::commit | ( |  | ) |
| virtual

Commits the current transaction and releases the connection to the pool.

Example:
  $db.commit();

Implements Qore::SQL::AbstractDatasource.

Qore::SQL::DatasourcePool::constructor | ( | string | driver,
|  | *string | user,
|  | *string | pass,
|  | *string | db,
|  | *string | encoding,
|  | *string | host,
|  | softint | min = `3`,
|  | softint | max = `10`,
|  | softint | port = `0`,
|  | *Qore::Thread::Queue | queue,
|  | any | arg
| ) |  |

Creates the DatasourcePool object; attempts to load a DBI driver if the driver is not already present in Qore.

Parameters

  driver | The name of the DBI driver for the Datasource. See SQL Constants for builtin constants for DBI drivers shipped with Qore, or see the DBI driver documentation to use an add-on driver (this string should be the name of the driver to be loaded)
  user | The user name for the new connection. Also see Datasource::setUserName() for a method that allows this parameter to be set after the constructor.
  pass | The password for the new connection. Also see Datasource::setPassword() for a method that allows this parameter to be set after the constructor.
  db | The database name for the new connection. Also see Datasource::setDBName() for a method that allows this parameter to be set after the constructor.
  encoding | The database-specific name of the character encoding to use for the new connection. Also see Datasource::setDBCharset() for a method that allows this parameter to be set after the constructor. If no value is passed for this parameter, then the database character encoding corresponding to the default character encoding will be used instead.
  host | The host name for the new connection. Also see Datasource::setHostName() for a method that allows this parameter to be set after the constructor.
  min | The minimum number of connections in the pool (this number of connections is opened in the constructor)
  max | The maximum number of connections in the pool (not more than this number of connections will be opened)
  port | The port number for the new connection. Also see Datasource::setPort() for a method that allows this parameter to be set after the constructor.
  queue | An optional Queue object to receive datasource events; note that the Queue passed cannot have any maximum size set or a `QUEUE-ERROR` will be thrown; passing NOTHING will clear any event queue
  arg | an optional argument to be included in the `arg` key of datasource events

Example:
  my DatasourcePool $db(DSPGSQL, "user", "pass", "database", "utf8", "localhost", 3, 10, 5432);

Exceptions

  DATASOURCEPOOL-UNSUPPORTED-DATABASE | DBI driver cannot be found
  DATASOURCEPOOL-CONSTRUCTOR-ERROR | invalid min, max, or port argument
  DBI-OPTION-ERROR | unknown or unsupported option passed to driver

Qore::SQL::DatasourcePool::constructor | ( | string | desc,
|  | *Qore::Thread::Queue | queue,
|  | any | arg
| ) |  |

Creates a DatasourcePool object from a single string giving all parameters that can be parsed by parse_datasource()

Parameters

  desc | a datasource description string in the format that can be parsed by parse_datasource()
  queue | An optional Queue object to receive datasource events; note that the Queue passed cannot have any maximum size set or a `QUEUE-ERROR` will be thrown; passing NOTHING will clear any event queue
  arg | an optional argument to be included in the `arg` key of datasource events

Example:
  my DatasourcePool ds("pgsql:user/pass@db01(utf8)%localhost:5432");

Exceptions

  DATASOURCE-UNSUPPORTED-DATABASE | DBI driver cannot be loaded
  DATASOURCE-CONSTRUCTOR-ERRO | missing required parameter for connection; port value is <= 0
  DBI-OPTION-ERROR | unknown or unsupported option passed to driver

Since
  Qore 0.8.6

Qore::SQL::DatasourcePool::constructor | ( | hash | opts,
|  | *Qore::Thread::Queue | queue,
|  | any | arg
| ) |  |

Creates a Datasource object from a hash argument giving parameters for the constructor.

Parameters

  opts | a hash giving parameters for the new datasource with the following possible keys (the `"type"` key is mandatory, also usable with the output of the parse_datasource() function): `type:` (*string) The name of the database driver to use; this key is mandatory; if not present, an exception will be raised. See SQL Constants for builtin constants for DBI drivers shipped with Qore, or see the DBI driver documentation to use an add-on driver (this string should be the name of the driver to be loaded) `user:` (*string) The user name for the new connection `pass:` (*string) The password for the new connection `db:` (*string) The database name for the new connection `charset:` (*string) The database-specific name of the character encoding to use for the new connection. Also see DatasourcePool::setDBCharset() for a method that allows this parameter to be set after the constructor. If no value is passed for this parameter, then the database character encoding corresponding to the default character encoding for the Qore process will be used instead. `host:` (*string) The host name for the new connection `port:` (softint) The port number for the new connection `options:` (hash) An optional hash having `"min"` and `"max"` keys giving the minimum and maximum number of connections in the pool, respectively; all other options will be passed to the database driver
  queue | An optional Queue object to receive datasource events; note that the Queue passed cannot have any maximum size set or a `QUEUE-ERROR` will be thrown; passing NOTHING will clear any event queue
  arg | an optional argument to be included in the `arg` key of datasource events

Example:
  my Datasource $db(("type": DSPGSQL, "user": "username", "pass": "password", "db": "database", "charset": "utf8", "host": "localhost", "port": 5432, "options": ("min": 3, "max": 10)));

Exceptions

  DATASOURCEPOOL-UNSUPPORTED-DATABASE | DBI driver cannot be loaded
  DATASOURCEPOOL-CONSTRUCTOR-ERROR | missing or invalid `"driver"` key, other key name not assigned to a string; `"port"` value is <= 0; invalid `"min"` or `"max"` keys
  DBI-OPTION-ERROR | unknown or unsupported option passed to driver

Qore::SQL::DatasourcePool::copy | ( |  | ) |

Creates a new Datasource object with the same driver as the original and copies of all the connection parameters.

Example:
  my DatasourcePool $new_dsp = $dsp.copy();

bool Qore::SQL::DatasourcePool::currentThreadInTransaction | ( |  | ) |

Returns True if the current thread is in a transaction (i.e. has a dedicated datasource allocation), False if not.

Returns
  True if the current thread is in a transaction (i.e. has a dedicated datasource allocation), False if not

Code Flags:
  CONSTANT

Example:
  my bool $b = $db.currentThreadInTransaction();

Since
  Qore 0.8.7

Qore::SQL::DatasourcePool::destructor | ( |  | ) |

Throws an exception if any transactions are in progress and returns immediately; the object is destroyed after any in-progress requests are completed.

Example:
  delete $db;

Exceptions

  DATASOURCEPOOL-ERROR | The destructor was called while a transaction was still in progress

any Qore::SQL::DatasourcePool::exec | ( | string | sql,
|  |  | ...
| ) |  |
| virtual

Allocates a persistent connection to the current thread from the pool (if one has not already been allocated) and executes an SQL command on the server and returns either the integer row count (for example, for updates, inserts, and deletes) or the data retrieved (for example, if a stored procedure is executed that returns values)

This method also accepts all bind parameters (`%d`, `%v`, `%s`, etc) as documented in Binding by Value and Placeholder

Parameters

  sql | The SQL command to execute on the server
  ... | Include any values to be bound (using `%v` in the command string) or placeholder specifications (using `:`key_name in the command string) in order after the command string

Returns
  The return value depends on the DBI driver; normally, for commands with placeholders, a hash is returned holding the values acquired from executing the SQL statement. For all other commands, normally an integer row count is returned. However, some DBI drivers also allow select statements to be executed through this interface, which would also return a hash (column names) of lists (values for each column).

Example:
  my int $rows = $db.exec("insert into table (varchar_col, timestamp_col, blob_col, numeric_col) values (%v, %v, %v, %d)", $string, now(), $binary, 100);

Note
  see the documentation for the DBI driver being used for additional possible exceptions

Implements Qore::SQL::AbstractDatasource.

any Qore::SQL::DatasourcePool::execRaw | ( | string | sql | ) |
| virtual

Allocates a persistent connection to the current thread from the pool (if one has not already been allocated) and executes an SQL command on the server and returns either the row count (for example, for updates and inserts) or the data retrieved (for example, if a stored procedure is executed that returns values)

This method does not do any variable binding, so it's useful for example for DDL statements etc

Warning:
  Using this method to execute pure dynamic SQL many times with different SQL strings (as opposed to using the same string and binding by value instead of dynamic SQL) can affect application performance by prohibiting the efficient usage of the DB server's statement cache. See DB server documentation for variable binding and the SQL statement cache for more information.

Parameters

  sql | The SQL command to execute on the server; this string will not be subjected to any transformations for variable binding

Returns
  The return value depends on the DBI driver; normally, for commands with placeholders, a hash is returned holding the values acquired from executing the SQL statement. For all other commands, normally an integer row count is returned. However, some DBI drivers also allow select statements to be executed through this interface, which would also return a hash (column names) of lists (values for each column).

Example:
  $db.execRaw("create table my_tab (id number, some_text varchar2(30))");

Note
  see the documentation for the DBI driver being used for additional possible exceptions

Implements Qore::SQL::AbstractDatasource.

any Qore::SQL::DatasourcePool::getClientVersion | ( |  | ) |
| virtual

Retrieves the driver-specific client library version information; this method may not be implemented for all drivers.

Returns
  the driver-specific client library version information; this method may not be implemented for all drivers; see the DBI driver documentation for the return data type and format

Example:
  my any $ver = $db.getClientVersion();

Note
  see the documentation for the DBI driver being used for possible exceptions

Implements Qore::SQL::AbstractDatasource.

hash Qore::SQL::DatasourcePool::getConfigHash | ( |  | ) |
| virtual

Returns a datasource hash describing the configuration of the current object.

Code Flags:
  CONSTANT

Example:
  my hash $h = $ds.getConfigHash();

Returns
  a datasource hash describing the configuration of the current object

Since
  Qore 0.8.8

Implements Qore::SQL::AbstractDatasource.

string Qore::SQL::DatasourcePool::getConfigString | ( |  | ) |
| virtual

Returns a string giving the configuration of the current object in a format that can be parsed by parse_datasource()

Code Flags:
  CONSTANT

Example:
  my string $str = $ds.getConfigString();

Returns
  a string giving the configuration of the current object in a format that can be parsed by parse_datasource()

Since
  Qore 0.8.8

Implements Qore::SQL::AbstractDatasource.

*string Qore::SQL::DatasourcePool::getDBCharset | ( |  | ) |

Retrieves the database-specific charset set encoding for the object.

A method synonym for DatasourcePool::getDBEncoding() kept for backwards-compatibility

Returns
  the database-specific charset set encoding for the object

Code Flags:
  CONSTANT

Example:
  my string $enc = $db.getDBCharset();

string Qore::SQL::DatasourcePool::getDBEncoding | ( |  | ) |
| virtual

Retrieves the database-specific charset set encoding for the object.

Returns
  the database-specific charset set encoding for the object

Code Flags:
  CONSTANT

Example:
  my string $enc = $db.getDBEncoding();

See Also
  DatasourcePool::getOSEncoding()

Implements Qore::SQL::AbstractDatasource.

*string Qore::SQL::DatasourcePool::getDBName | ( |  | ) |
| virtual

Returns the database name parameter as a string or NOTHING if none is set.

Returns
  the database name parameter as a string or NOTHING if none is set

Code Flags:
  CONSTANT

Example:
  my *string $db = $db.getDBName();

Implements Qore::SQL::AbstractDatasource.

string Qore::SQL::DatasourcePool::getDriverName | ( |  | ) |
| virtual

Returns the name of the driver used for the object.

Returns
  the name of the driver used for the object

Code Flags:
  CONSTANT

Example:
  my string $driver = $db.getDriverName();

Implements Qore::SQL::AbstractDatasource.

int Qore::SQL::DatasourcePool::getErrorTimeout | ( |  | ) |

Returns the error timeout period for waiting for a connection to come free as an integer giving milliseconds; note that timeout values less than or equal to zero mean that requests for a connection will wait indefinitely.

Code Flags:
  CONSTANT

Example:
  my int $ms = $ds.getErrorTimeout();

Returns
  the error timeout period for waiting for a connection to come free as an integer giving milliseconds; note that timeout values less than or equal to zero mean that requests for a connection will wait indefinitely

Since
  Qore 0.8.9

*string Qore::SQL::DatasourcePool::getHostName | ( |  | ) |
| virtual

Returns the hostname parameter as a string or NOTHING if none is set.

Returns
  the hostname parameter as a string or NOTHING if none is set

Code Flags:
  CONSTANT

Example:
  my *string $host = $db.getHostName();

Implements Qore::SQL::AbstractDatasource.

int Qore::SQL::DatasourcePool::getMaximum | ( |  | ) |

Returns the maximum number of connections in this object.

Returns
  the maximum number of connections in this object

Code Flags:
  CONSTANT

Example:
  my int $max = $db.getMaximum();

int Qore::SQL::DatasourcePool::getMinimum | ( |  | ) |

Returns the minimum number of connections in this object.

Returns
  the minimum number of connections in this object

Code Flags:
  CONSTANT

Example:
  my int $min = $db.getMinimum();

any Qore::SQL::DatasourcePool::getOption | ( | string | opt | ) |

Returns the current value for the given option.

Code Flags:
  RET_VALUE_ONLY

Parameters

  opt | the option to get

Exceptions

  DBI-OPTION-ERROR | unknown or unsupported option passed to driver

Since
  Qore 0.8.6

hash Qore::SQL::DatasourcePool::getOptionHash | ( |  | ) |

returns the valid options for the driver associated with the Datasource with descriptions and current values for the current Datasource object

Code Flags:
  CONSTANT

Returns
  a hash where the keys are valid option names, and the values are hashes with the following keys:
  - `"desc"`: a string description of the option
  - `"type"`: a string giving the data type restriction for the option
  - `"value"`: the current value of the option

Since
  Qore 0.8.6

string Qore::SQL::DatasourcePool::getOSCharset | ( |  | ) |

Returns the Qore character encoding name for the object as a string or `"(unknown)"` if none is set.

Returns
  the Qore character encoding name for the object as a string or `"(unknown)"` if none is set

Code Flags:
  CONSTANT

Example:
  my string $enc = $db.getOSCharset();

See Also
  DatasourcePool::getOSEncoding()

*string Qore::SQL::DatasourcePool::getOSEncoding | ( |  | ) |
| virtual

Returns the Qore character encoding name for the object as a string or NOTHING if none is set.

Returns
  the Qore character encoding name for the object as a string or NOTHING if none is set

Code Flags:
  CONSTANT

Example:
  my *string $enc = $db.getOSEncoding();

Implements Qore::SQL::AbstractDatasource.

*string Qore::SQL::DatasourcePool::getPassword | ( |  | ) |
| virtual

Returns the password parameter as a string or NOTHING if none is set.

Returns
  the password parameter as a string or NOTHING if none is set

Code Flags:
  CONSTANT

Example:
  my *string $pass = $db.getPassword();

Implements Qore::SQL::AbstractDatasource.

*int Qore::SQL::DatasourcePool::getPort | ( |  | ) |
| virtual

Gets the port number that will be used for the next connection to the server.

Invalid port numbers will cause an exception to be thrown when the connection is opened

Code Flags:
  CONSTANT

Example:
  my *int $port = $db.getPort();

Implements Qore::SQL::AbstractDatasource.

any Qore::SQL::DatasourcePool::getServerVersion | ( |  | ) |
| virtual

Returns the driver-specific server version data for the current connection.

Returns
  the driver-specific server version data for the current connection; see the DBI driver documentation for the return data type and format

Example:
  my any $ver = $db.getServerVersion();

Note
  see the documentation for the DBI driver being used for additional possible exceptions

Implements Qore::SQL::AbstractDatasource.

*hash Qore::SQL::DatasourcePool::getUsageInfo | ( |  | ) |

Returns a hash with usage information about the DatasourcePool object.

Code Flags:
  CONSTANT

Example:
  my hash $h = $ds.getUsageInfo();

Returns
  a hash with the following keys (note that the `callback`, `timeout`, and optionally `arg` keys are only set if a warning callback is set):
  - `callback:` the closure or call reference set as the warning callback
  - `timeout:` an integer giving the timeout threshold in milliseconds before the warning callback is executed
  - `arg:` an optional argument passed to the warning callback
  - `wait_max:` the maximum number of microseconds that threads have had to wait for a free connection
  - `stats_reqs:` the total number of requests for connections / transactions on this DatasourcePool
  - `stats_hits:` the total number of requests for connections / transactions on this DatasourcePool that did not have to wait for a connection

Note
  `wait_max` is reported in microseconds (1 ms = 1000 us) while the warning timeout has a resolution of milliseconds

Since
  Qore 0.8.9

*string Qore::SQL::DatasourcePool::getUserName | ( |  | ) |
| virtual

Returns the username parameter as a string or NOTHING if none is set.

Returns
  the username parameter as a string or NOTHING if none is set

Code Flags:
  CONSTANT

Example:
  my *string $user = $db.getUserName();

Implements Qore::SQL::AbstractDatasource.

bool Qore::SQL::DatasourcePool::inTransaction | ( |  | ) |
| virtual

Returns True if a transaction is currently in progress (meaning in this case that a datasource form the pool is dedicated to the calling thread), False if not.

Returns
  True if a transaction is currently in progress (meaning in this case that a datasource form the pool is dedicated to the calling thread), False if not

Code Flags:
  CONSTANT

Example:
  my bool $b = $db.inTransaction();

Implements Qore::SQL::AbstractDatasource.

nothing Qore::SQL::DatasourcePool::rollback | ( |  | ) |
| virtual

Rolls back the current transaction and releases the connection to the pool.

Example:
  $db.rollback();

Implements Qore::SQL::AbstractDatasource.

any Qore::SQL::DatasourcePool::select | ( | string | sql,
|  |  | ...
| ) |  |
| virtual

Executes an SQL select statement on the server and returns the result as a hash (column names) of lists (column values per row)

The return format of this method is suitable for use with context statements, for easy iteration and processing of query results. Alternatively, the HashListIterator class can be used to iterate the return value of this method.

Additionally, this format is a more efficient format than that returned by the Datasource::selectRows() method, because the column names are not repeated for each row returned. Therefore, for retrieving anything greater than small amounts of data, it is recommended to use this method instead of Datasource::selectRows().

This method also accepts all bind parameters (`%d`, `%v`, `%s`, etc) as documented in Binding by Value and Placeholder

This method does not retain the datasource connection for the current thread if one was not already allocated before this method is called, so to execute select statements that begin a transaction (such as `"select for update"`), execute DatasourcePool::beginTransaction() first to ensure that the connection is dedicated to the calling thread.

Parameters

  sql | The SQL command to execute on the server
  ... | Include any values to be bound (using `%v` in the command string) or placeholder specifications (using `:`key_name in the command string) in order after the command string

Returns
  This method returns a hash (the keys are the column names) of lists (the column data per row) when executed with an SQL select statement, however some DBI drivers allow any SQL to be executed through this method, in which case other data types can be returned (such as an integer for a row count or a hash for output parameters when executing a stored procedure)

Example:
  # bind a string and a date/time value by value in a query
  $query = $db.select("select * from table where varchar_column = %v and timestamp_column > %v", $string, 2007-10-11T15:31:26.289);

Note
  - See the documentation for the DBI driver being used for additional possible exceptions
  - This method returns all the data available immediately; to process query data piecewise, use the SQLStatement class

See Also
  - DatasourcePool::vselect()
  - <hash>::contextIterator()
  - context Statements

Implements Qore::SQL::AbstractDatasource.

any Qore::SQL::DatasourcePool::selectRow | ( | string | sql,
|  |  | ...
| ) |  |
| virtual

Executes an SQL select statement on the server and returns the first row as a hash (the column values)

If more than one row is returned, then it is treated as an error and a `DBI-SELECT-ROW-ERROR` is returned (however the DBI driver should raise its own exception here to avoid retrieving more than one row from the server). For a similar method taking a list for all bind arguments, see DatasourcePool::vselectRow().

This method also accepts all bind parameters (`%d`, `%v`, `%s`, etc) as documented in Binding by Value and Placeholder

This method does not retain the datasource connection for the current thread if one was not already allocated before this method is called, so to execute select statements that begin a transaction (such as `"select for update"`), execute DatasourcePool::beginTransaction() first to ensure that the connection is dedicated to the calling thread.

Parameters

  sql | The SQL command to execute on the server
  ... | Include any values to be bound (using `%v` in the command string) or placeholder specifications (using `:`key_name in the command string) in order after the command string

Returns
  This method normally returns a hash (the keys are the column names) of row data or NOTHING if no row is found for the query when executed with an SQL select statement, however some DBI drivers allow any SQL statement to be executed through this method (not only select statements), in this case other data types can be returned

Example:
  my *hash $h = $db.selectRow("select * from example_table where id = 1");

Exceptions

  DBI-SELECT-ROW-ERROR | more than 1 row retrieved from the server

Note
  see the documentation for the DBI driver being used for additional possible exceptions

Implements Qore::SQL::AbstractDatasource.

any Qore::SQL::DatasourcePool::selectRows | ( | string | sql,
|  |  | ...
| ) |  |
| virtual

Executes an SQL select statement on the server and returns the result as a list (rows) of hashes (the column values)

The return format of this method is not as memory efficient as that returned by the DatasourcePool::select() method, therefore for larger amounts of data, it is recommended to use DatasourcePool::select().

The usual return value of this method can be iterated with the ListHashIterator class.

This method also accepts all bind parameters (`%d`, `%v`, `%s`, etc) as documented in Binding by Value and Placeholder

This method does not retain the datasource connection for the current thread if one was not already allocated before this method is called, so to execute select statements that begin a transaction (such as `"select for update"`), execute DatasourcePool::beginTransaction() first to ensure that the connection is dedicated to the calling thread.

Parameters

  sql | The SQL command to execute on the server
  ... | Include any values to be bound (using `%v` in the command string) or placeholder specifications (using `:`key_name in the command string) in order after the command string

Returns
  Normally returns a list (rows) of hash (where the keys are the column names of each row) or NOTHING if no rows are found for the query, however some DBI drivers allow any SQL statement to be executed through this method (not only select statements), in this case other data types can be returned

Example:
  my *list $list = $db.selectRows("select * from example_table");

Note
  see the documentation for the DBI driver being used for additional possible exceptions

See Also
  DatasourcePool::select()

Implements Qore::SQL::AbstractDatasource.

Qore::SQL::DatasourcePool::setErrorTimeout | ( | timeout | ts | ) |

Sets the timeout period for waiting for a connection to come free; note that timeout values less than or equal to zero mean that requests for a connection will wait indefinitely.

Example:
  $ds.setErrorTimeout(30s);

Since
  Qore 0.8.9

nothing Qore::SQL::DatasourcePool::setEventQueue | ( | Qore::Thread::Queue | queue,
|  | any | arg
| ) |  |

Sets a queue object for DBI events on the pool.

Parameters

  queue | the Queue object to receive datasource events; note that the Queue passed cannot have any maximum size set or a `QUEUE-ERROR` will be thrown; passing NOTHING will clear any event queue
  arg | an argument to be included in the `arg` key of datasource events

Exceptions

  QUEUE-ERROR | the Queue passed has a maximum size set

Since
  Qore 0.8.9

Qore::SQL::DatasourcePool::setWarningCallback | ( | timeout | ms,
|  | code | callback,
|  | any | arg
| ) |  |

sets a connection delay warning callback to be called any time the delay assigning a connection from the pool exceeds the given timeout in milliseconds

Example:
  my code $cb = sub (string $dsstr, int $us, int $to) {
  printf("WARNING: datasource pool %y took %f ms (threshold %d ms) to assign a new connection\n", $dsstr, $us.toNumber() / 1000n, $to);
  };
  $ds.setWarningCallback(5s, $cb);

Parameters

  ms | the period of time with a resolution of milliseconds after which the callback will be called if a connection cannot be allocated in the given time period
  callback | a closure or call reference taking three or four arguments: (string desc, int time, int warning_timeout[, any arg]) which will be passed a datasource description string for the pool, an integer giving the amount of time it took to acquire the connection in microseconds (divide by 1000 to get milliseconds), an integer giving the warning timeout threshold in milliseconds, and optionally the arg value passed to this method
  arg | an optional argument that will be passed to the warning callback

Note
  that the warning timeout has a resolution of milliseconds, but the actual wait time is reported in microseconds (1 ms = 1000 us)

Since
  Qore 0.8.9

string Qore::SQL::DatasourcePool::toString | ( |  | ) |

Returns a string with technical information about the object.

Returns
  a string with technical information about the object

Code Flags:
  CONSTANT

Example:
  my string $str = $db.toString();

any Qore::SQL::DatasourcePool::vexec | ( | string | sql,
|  | *softlist | vargs
| ) |  |
| virtual

Allocates a persistent connection to the current thread from the pool (if one has not already been allocated) and executes SQL code on the DB connection, taking a list for all bind arguments.

Same as DatasourcePool::exec() except takes an explicit list for bind arguments

This method also accepts all bind parameters (`%d`, `%v`, `%s`, etc) as documented in Binding by Value and Placeholder

Parameters

  sql | The SQL command to execute on the server
  vargs | Include any values to be bound (using `%v` in the command string) or placeholder specifications (using `:`key_name in the command string) in order after the command string

Returns
  The return value depends on the DBI driver; normally, for commands with placeholders, a hash is returned holding the values acquired from executing the SQL statement. For all other commands, normally an integer row count is returned. However, some DBI drivers also allow select statements to be executed through this interface, which would also return a hash (column names) of lists (values for each column).

Example:
  my int $rows = $db.vexec("insert into example_table value (%v, %v, %v)", $arg_list);

Note
  see the documentation for the DBI driver being used for additional possible exceptions

Implements Qore::SQL::AbstractDatasource.

any Qore::SQL::DatasourcePool::vselect | ( | string | sql,
|  | *softlist | vargs
| ) |  |
| virtual

Executes a select statement on the server and returns the results in a hash (column names) of lists (column values per row), taking a list for all bind arguments.

The return format of this method is suitable for use with context statements, for easy iteration and processing of query results. Alternatively, the HashListIterator class can be used to iterate the return value of this method.

This method also accepts all bind parameters (`%d`, `%v`, `%s`, etc) as documented in Binding by Value and Placeholder

This method does not retain the datasource connection for the current thread if one was not already allocated before this method is called, so to execute select statements that begin a transaction (such as `"select for update"`), execute DatasourcePool::beginTransaction() first to ensure that the connection is dedicated to the calling thread.

Parameters

  sql | The SQL command to execute on the server
  vargs | Include any values to be bound (using `%v` in the command string) or placeholder specifications (using `:`key_name in the command string) in order after the command string

Returns
  Normally returns a hash (the keys are the column names) of list (each hash key's value is a list giving the row data), however some DBI drivers allow any SQL statement to be executed through this method (not only select statements), in this case other data types can be returned

Example:
  my *hash $query = $db.vselect("select * from example_table where id = %v and name = %v", $arg_list);

Note
  - See the documentation for the DBI driver being used for additional possible exceptions
  - This method returns all the data available immediately; to process query data piecewise, use the SQLStatement class

See Also
  - DatasourcePool::select()
  - <hash>::contextIterator()
  - context Statements

Implements Qore::SQL::AbstractDatasource.

any Qore::SQL::DatasourcePool::vselectRow | ( | string | sql,
|  | *softlist | vargs
| ) |  |
| virtual

Executes a select statement on the server and returns the first row as a hash (column names and values), taking a list for all bind arguments.

This method is the same as the DatasourcePool::selectRow() method, except this method takes a single argument after the SQL command giving the list of bind value parameters

This method also accepts all bind parameters (`%d`, `%v`, `%s`, etc) as documented in Binding by Value and Placeholder

This method does not retain the datasource connection for the current thread if one was not already allocated before this method is called, so to execute select statements that begin a transaction (such as `"select for update"`), execute DatasourcePool::beginTransaction() first to ensure that the connection is dedicated to the calling thread.

Parameters

  sql | The SQL command to execute on the server
  vargs | Include any values to be bound (using `%v` in the command string) or placeholder specifications (using `:`key_name in the command string) in order after the command string

Returns
  This method normally returns a hash (the keys are the column names) of row data or NOTHING if no row is found for the query when executed with an SQL select statement, however some DBI drivers allow any SQL statement to be executed through this method (not only select statements), in this case other data types can be returned

Example:
  my *hash $h = $db.vselectRow("select * from example_table where id = %v and type = %v", $arg_list);

Note
  see the documentation for the DBI driver being used for additional possible exceptions

See Also
  DatasourcePool::selectRow()

Implements Qore::SQL::AbstractDatasource.

any Qore::SQL::DatasourcePool::vselectRows | ( | string | sql,
|  | *softlist | vargs
| ) |  |
| virtual

Executes a select statement on the server and returns the results in a list (rows) of hashes (column names and values), taking a list for all bind arguments.

Same as the Datasource::selectRows() method, except this method takes a single argument after the SQL command giving the list of bind value parameters.

The usual return value of this method can be iterated with the ListHashIterator class.

The return format of this method is not as memory efficient as that returned by the DatasourcePool::select() method, therefore for larger amounts of data, it is recommended to use DatasourcePool::select().

This method also accepts all bind parameters (`%d`, `%v`, `%s`, etc) as documented in Binding by Value and Placeholder

This method does not retain the datasource connection for the current thread if one was not already allocated before this method is called, so to execute select statements that begin a transaction (such as `"select for update"`), execute DatasourcePool::beginTransaction() first to ensure that the connection is dedicated to the calling thread.

Parameters

  sql | The SQL command to execute on the server
  vargs | Include any values to be bound (using `%v` in the command string) or placeholder specifications (using `:`key_name in the command string) in order after the command string

Returns
  Normally returns a list (rows) of hash (where the keys are the column names of each row) or NOTHING if no rows are found for the query, however some DBI drivers allow any SQL statement to be executed through this method (not only select statements), in this case other data types can be returned

Example:
  my *list $list = $db.vselectRows("select * from example_table where id = %v and type = %v", $arg_list);

Note
  see the documentation for the DBI driver being used for additional possible exceptions

See Also
  DatasourcePool::selectRows()

Implements Qore::SQL::AbstractDatasource.